Exception.InnerException Vlastnost

Definice

Získá Exception instanci, která způsobila aktuální výjimku.Gets the Exception instance that caused the current exception.

public:
 property Exception ^ InnerException { Exception ^ get(); };
public Exception InnerException { get; }
public Exception? InnerException { get; }
member this.InnerException : Exception
Public ReadOnly Property InnerException As Exception

Hodnota vlastnosti

Exception

Objekt, který popisuje chybu, která způsobila aktuální výjimku.An object that describes the error that caused the current exception. InnerExceptionVlastnost vrací stejnou hodnotu, jako byla předána Exception(String, Exception) konstruktoru, nebo pokud nebyla null zadána hodnota vnitřní výjimky do konstruktoru.The InnerException property returns the same value as was passed into the Exception(String, Exception) constructor, or null if the inner exception value was not supplied to the constructor. Tato vlastnost je jen ke čtení.This property is read-only.

Implementuje

Příklady

Následující příklad ukazuje vyvolání a zachycení výjimky, která odkazuje na vnitřní výjimku.The following example demonstrates throwing and catching an exception that references an inner exception.

using namespace System;

public ref class AppException: public Exception
{
public:
   AppException(String^ message ) : Exception(message)
   {}

   AppException(String^ message, Exception^ inner) : Exception(message, inner)
   {}
};

public ref class Example
{
public:
   void ThrowInner()
   {
      throw gcnew AppException("Exception in ThrowInner method.");
   }

   void CatchInner()
   {
      try {
         this->ThrowInner();
      }
      catch (AppException^ e) {
         throw gcnew AppException("Error in CatchInner caused by calling the ThrowInner method.", e);
      }
   }
};

int main()
{
   Example^ ex = gcnew Example();
   try {
      ex->CatchInner();
   }
   catch (AppException^ e) {
      Console::WriteLine("In catch block of Main method.");
      Console::WriteLine("Caught: {0}", e->Message);
      if (e->InnerException != nullptr)
         Console::WriteLine("Inner exception: {0}", e->InnerException);
   }
}
// The example displays the following output:
//    In catch block of Main method.
//    Caught: Error in CatchInner caused by calling the ThrowInner method.
//    Inner exception: AppException: Exception in ThrowInner method.
//       at Example.ThrowInner()
//       at Example.CatchInner()
using System;

public class AppException : Exception
{
   public AppException(String message) : base (message)
   {}

   public AppException(String message, Exception inner) : base(message,inner) {}
}

public class Example
{
   public static void Main()
   {
      Example ex = new Example();

      try {
         ex.CatchInner();
      }
      catch(AppException e) {
         Console.WriteLine ("In catch block of Main method.");
         Console.WriteLine("Caught: {0}", e.Message);
         if (e.InnerException != null)
            Console.WriteLine("Inner exception: {0}", e.InnerException);
      }
   }

   public void ThrowInner ()
   {
      throw new AppException("Exception in ThrowInner method.");
   }

   public void CatchInner()
   {
      try {
         this.ThrowInner();
      }
      catch (AppException e) {
         throw new AppException("Error in CatchInner caused by calling the ThrowInner method.", e);
      }
   }
}
// The example displays the following output:
//    In catch block of Main method.
//    Caught: Error in CatchInner caused by calling the ThrowInner method.
//    Inner exception: AppException: Exception in ThrowInner method.
//       at Example.ThrowInner()
//       at Example.CatchInner()
Public Class AppException : Inherits Exception
   Public Sub New(message As String)
      MyBase.New(message)
   End Sub
   
   Public Sub New(message As String, inner As Exception)
      MyBase.New(message, inner)
   End Sub
End Class

Public Class Example
   Public Shared Sub Main()
      Dim testInstance As New Example()
      Try
         testInstance.CatchInner()
      Catch e As AppException
         Console.WriteLine ("In catch block of Main method.")
         Console.WriteLine("Caught: {0}", e.Message)
         If e.InnerException IsNot Nothing Then
            Console.WriteLine("Inner exception: {0}", e.InnerException)
         End If
      End Try
   End Sub
   
   Public Sub ThrowInner()
      Throw New AppException("Exception in ThrowInner method.")
   End Sub
   
   Public Sub CatchInner()
      Try
         Me.ThrowInner()
      Catch e As AppException
         Throw New AppException("Error in CatchInner caused by calling the ThrowInner method.", e)
      End Try
   End Sub
End Class
' The example displays the following output:
'    In catch block of Main method.
'    Caught: Error in CatchInner caused by calling the ThrowInner method.
'    Inner exception: AppException: Exception in ThrowInner method.
'       at Example.ThrowInner()
'       at Example.CatchInner()

Poznámky

Pokud je výjimka X vyvolána jako přímý výsledek předchozí výjimky Y , InnerException vlastnost X by měla obsahovat odkaz na Y .When an exception X is thrown as a direct result of a previous exception Y, the InnerException property of X should contain a reference to Y.

Použijte InnerException vlastnost k získání sady výjimek, které vedly k aktuální výjimce.Use the InnerException property to obtain the set of exceptions that led to the current exception.

Můžete vytvořit novou výjimku, která zachytí předchozí výjimku.You can create a new exception that catches an earlier exception. Kód, který zpracovává druhou výjimku, může využít další informace z předchozí výjimky pro zajištění správné manipulace s chybou.The code that handles the second exception can make use of the additional information from the earlier exception to handle the error more appropriately.

Předpokládejme, že je funkce, která čte soubor a formátuje data z tohoto souboru.Suppose that there is a function that reads a file and formats the data from that file. V tomto příkladu, když se kód pokusí přečíst soubor, IOException je vyvolána výjimka.In this example, as the code tries to read the file, an IOException is thrown. Funkce zachytí IOException a vyvolá výjimku FileNotFoundException .The function catches the IOException and throws a FileNotFoundException. IOExceptionMohl by být uložen ve InnerException vlastnosti FileNotFoundException , který umožňuje kód, který zachytává, FileNotFoundException aby kontroloval příčinu počáteční chyby.The IOException could be saved in the InnerException property of the FileNotFoundException, enabling the code that catches the FileNotFoundException to examine the cause of the initial error.

InnerExceptionVlastnost, která obsahuje odkaz na vnitřní výjimku, je nastavena při inicializaci objektu Exception.The InnerException property, which holds a reference to the inner exception, is set upon initialization of the exception object.

Platí pro